/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-06 Roberto Lopez <roblez@ciudad.com.ar>
 * http://www.geocities.com/harbour_minigui/
 *
 * Copyright 2005-06 Grigory Filatov <gfilatov@freemail.ru>
*/

ANNOUNCE RDDSYS

#include <minigui.ch>
#include <common.ch>

// ini CdQ Mod
// #define IDI_MAIN 1001
#define IDI_MAIN "icono"
// end CdQ Mod

Static aGet

PROCEDURE Main
// ini CdQ Mod
// LOCAL cPath := GetStartUpFolder() + "\", cFileName := cFileNoExt( GetExeFileName() )
LOCAL US_ExeName:=GetExeName(GetInstance())
      US_ExeName:=substr(US_ExeName,rat("\",US_ExeName) + 1)
PRIVATE cPath := GetCurrentFolder() + "\", cFileName := cFileNoExt( US_ExeName )
// end CdQ Mod

   PRIVATE cCfgFile := cPath + Lower(cFileName) + ".ini"
   PRIVATE aEntry := {}, cCryptKey := REPL( "#$@%&", 2 )

   aAdd( aEntry, "SMTP" )
   aAdd( aEntry, "From" )
   aAdd( aEntry, "To" )
   aAdd( aEntry, "CC" )
   aAdd( aEntry, "BCC" )
   aAdd( aEntry, "Subject" )
   aAdd( aEntry, "Attachment" )
   aAdd( aEntry, "Message" )
   aAdd( aEntry, "Login" )
   aAdd( aEntry, "LoginMD5" )
   aAdd( aEntry, "User" )
   aAdd( aEntry, "PassWord" )
   aAdd( aEntry, "HTML" )

        aGet := array(13)

        DEFAULT aget[1] TO "smtp.domain.com"
        DEFAULT aget[2] TO "Sender <sender@domain.com>"
        DEFAULT aget[3] TO "Recipient <recipient@domain.com>"
        DEFAULT aget[4] TO SPACE(30)
        DEFAULT aget[5] TO SPACE(30)
      // ini CdQ Mod
      //DEFAULT aget[6] TO "This is a Test"
        DEFAULT aget[6] TO "Test from " + MiniGuiVersion()
      // end CdQ Mod
        DEFAULT aget[7] TO {}
      // ini CdQ Mod
      //DEFAULT aget[8] TO "This is a Test"
        DEFAULT aget[8] TO "Test from " + MiniGuiVersion() + " and " + version()
      // end CdQ Mod
        aGet[ 9] := .F.
        aGet[10] := .F.
        DEFAULT aget[11] TO ""
        DEFAULT aget[12] TO ""
        aGet[13] := 1

        IF FILE(cCfgFile)

                BEGIN INI FILE cCfgFile

                        For i := 1 To Len(aEntry)
                                GET aGet[i] SECTION "Data" ENTRY aEntry[i]
                        Next i
                        aGet[8] := STRTRAN( aGet[8], Chr(250), CRLF )
                     // ini CdQ Mod
                     // aGet[12] := CHARXOR( aGet[12], cCryptKey )
                        if !empty( aGet[12] )
                           aGet[12] := CHARXOR( aGet[12], cCryptKey )
                        endif
                     // end CdQ Mod

                END INI

        ENDIF

        DEFINE WINDOW Form_1 AT 131,220 WIDTH 643 HEIGHT 486 + IF(IsXPThemeActive(), 6, 0) ;
                TITLE "Harbour Mailer" ;
                ICON IDI_MAIN ;
                MAIN ;
                NOMINIMIZE NOMAXIMIZE NOSIZE ;
                ON RELEASE SaveData() ;
                FONT "MS Sans Serif" SIZE 10

                @ 9,7 FRAME Frame_1 WIDTH 620 HEIGHT 40

                @ 17,20  BUTTON PicButton_1 PICTURE "SEND" ACTION m_send() WIDTH 24 HEIGHT 24 TOOLTIP "Send Mail"
                @ 17,48  BUTTON PicButton_2 PICTURE "CONFIG" ACTION m_config() WIDTH 24 HEIGHT 24 TOOLTIP "Config"
                @ 17,76  BUTTON PicButton_3 PICTURE "INFO" ACTION m_about() WIDTH 24 HEIGHT 24 TOOLTIP "About"
                @ 17,104 BUTTON PicButton_4 PICTURE "EXIT" ACTION Form_1.Release WIDTH 24 HEIGHT 24 TOOLTIP "Exit"

                @ 62,7 FRAME Frame_2 WIDTH 620 HEIGHT 390

                @ 84,24 LABEL Label_1 VALUE "SMTP Server" WIDTH 100 HEIGHT 20
                @ 108,24 LABEL Label_2 VALUE "From" WIDTH 100 HEIGHT 20
                @ 131,24 LABEL Label_3 VALUE "To" WIDTH 100 HEIGHT 20
                @ 158,24 LABEL Label_4 VALUE "Cc" WIDTH 100 HEIGHT 20
                @ 185,24 LABEL Label_5 VALUE "Subject" WIDTH 100 HEIGHT 20
                @ 210,24 LABEL Label_6 VALUE "Attachment" WIDTH 100 HEIGHT 20
                @ 236,24 LABEL Label_7 VALUE "Message" WIDTH 100 HEIGHT 20

                @ 78,135 TEXTBOX Text_1 HEIGHT 23 WIDTH 480 ON CHANGE aget[1] := Form_1.Text_1.Value
                Form_1.Text_1.Value := aget[1]

                @ 104,135 TEXTBOX Text_2 HEIGHT 22 WIDTH 480 ON CHANGE aget[2] := Form_1.Text_2.Value
                Form_1.Text_2.Value := aget[2]

                @ 129,135 TEXTBOX Text_3 HEIGHT 22 WIDTH 480 ON CHANGE aget[3] := Form_1.Text_3.Value
                Form_1.Text_3.Value := aget[3]

                @ 155,135 TEXTBOX Text_4 HEIGHT 22 WIDTH 200 ON CHANGE aget[4] := Form_1.Text_4.Value
                Form_1.Text_4.Value := aget[4]

                @ 158,357 LABEL Label_8 VALUE "Bcc" WIDTH 58 HEIGHT 20

                @ 155,415 TEXTBOX Text_5 HEIGHT 22 WIDTH 200 ON CHANGE aget[5] := Form_1.Text_5.Value
                Form_1.Text_5.Value := aget[5]

                @ 180,135 TEXTBOX Text_6 HEIGHT 22 WIDTH 480 ON CHANGE aget[6] := Form_1.Text_6.Value
                Form_1.Text_6.Value := aget[6]

                @ 205,135 COMBOBOX Combo_7 ITEMS aget[7] HEIGHT 200 WIDTH 450
                Form_1.Combo_7.Value := IF(Len(aget[7]) == 0, 0, 1)

                @ 205,590 BUTTON PicButton_5 PICTURE "OPEN" ACTION File_Attached() ;
                        WIDTH 24 HEIGHT 24 TOOLTIP "Select a File(s) To Attach"

                @ 260,24 RADIOGROUP Radio_1 OPTIONS { "Text", "HTML" } VALUE aget[13] ;
                        WIDTH 64 TOOLTIP "Select a Message Format" ;
                        ON CHANGE aget[13] := Form_1.Radio_1.Value

                @ 232,135 EDITBOX Edit_1 WIDTH 480 HEIGHT 205 ON CHANGE aget[8] := Form_1.Edit_1.Value NOHSCROLL
                Form_1.Edit_1.Value := aget[8]

                ON KEY ALT+S ACTION m_send()
                ON KEY ALT+C ACTION m_config()
                ON KEY ALT+A ACTION m_about()

                ON KEY ALT+X ACTION ReleaseAllWindows()

        END WINDOW

        CENTER WINDOW Form_1

        ACTIVATE WINDOW Form_1

RETURN

STATIC PROCEDURE m_send()
   LOCAL i, oSocket, cSMTP, cFrom, cTo, cSubject, cMsgBody, aAttachment
   LOCAL lLogin, lLoginMD5, cUserID, cPassWord, lHTML, cUser := ""

   cSMTP       := aget[ 1]
   cFrom       := aget[ 2]
   cTo         := aget[ 3]
   cCC         := aget[ 4]
   cBCC        := aget[ 5]
   cSubject    := aget[ 6]
   aAttachment := aget[ 7]
   cMsgBody    := aget[ 8]
   lLogin      := aGet[ 9]
   lLoginMD5   := aGet[10]
   cUserID     := aGet[11]
   cPassWord   := aGet[12]
   lHTML       := ( aget[13] == 2 )

   oSocket := TSMTP():New()

   IF oSocket:Connect( cSMTP )

      i := At("<", cFrom)
      IF i > 0
//         cUser := Left(cFrom, i-1)
         cFrom := Substr(cFrom, i+1, Len(cFrom)-i-1)
      ENDIF
      i := At("<", cTo)
      IF i > 0
         cTo := Substr(cTo, i+1, Len(cTo)-i-1)
      ENDIF

      i := At("<", cCC)
      IF i > 0
         cCC := Substr(cCC, i+1, Len(cCC)-i-1)
      ENDIF
      i := At("<", cBCC)
      IF i > 0
         cBCC := Substr(cBCC, i+1, Len(cBCC)-i-1)
      ENDIF

      oSocket:ClearData()
      oSocket:SetFrom( cUser, cFrom )

      oSocket:AddTo( cUser, cTo )
      IF ! EMPTY( cCC )
         oSocket:AddCc( cUser, cCC )
      ENDIF
      IF ! EMPTY( cBCC )
         oSocket:AddBcc( cUser, cBCC )
      ENDIF

      oSocket:SetSubject( cSubject )

      IF LEN( aAttachment ) > 0
           FOR i := 1 TO LEN( aAttachment )
               oSocket:AddAttach( aAttachment[i] )
           NEXT i
      ENDIF

      oSocket:SetData( cMsgBody, lHTML )

      IF lLogin
         IF lLoginMD5
            IF ! oSocket:LoginMD5( cUserID, cPassWord )
               MsgStop( oSocket:cError, "While trying to login got an error messages from server" )
               oSocket:Close()
               RETURN
            ENDIF
         ELSEIF ! oSocket:Login( cUserID, cPassWord )
            MsgStop( oSocket:cError, "While trying to login got an error messages from server" )
            oSocket:Close()
            RETURN
         ENDIF
      ENDIF

      IF ! oSocket:Send(.T.)
         MsgStop( oSocket:cError, "While trying to send data got an error messages from server" )
         oSocket:Close()
         RETURN
      ENDIF

      oSocket:Close()

      MsgInfo( "Mail sent to " + cTo + " successfully!", "Harbour Mailer" )

   ELSE

      MsgStop( "Can't connect to SMTP server: " + cSMTP, "Error while trying to connect to SMTP server" )

   ENDIF

RETURN

STATIC PROCEDURE m_config()

      // ini CdQ Mod
      //DEFINE WINDOW Form_2 AT 199,144 WIDTH 374 HEIGHT 221 ;
      //        TITLE "Harbour Mailer Config" ;
      //        ICON IDI_MAIN MODAL NOSIZE ;
      //        ON INIT Form_2.Button_1.Setfocus ;
      //        FONT "MS Sans Serif" SIZE 10
      //
        DEFINE WINDOW Form_2 AT 199,144 WIDTH 374 HEIGHT 221 ;
                TITLE "Harbour Mailer Config" ;
                ICON IDI_MAIN MODAL NOSIZE ;
                ON INIT DoMethod( "Form_2" , "Button_1" , "Setfocus" ) ;
                FONT "MS Sans Serif" SIZE 10
      // end CdQ Mod

                @ 8,8 FRAME Frame_1 WIDTH 350 HEIGHT 138

                @ 22,25 CHECKBOX CheckBox_1 CAPTION "My server requires authentication" ;
                        WIDTH 240 HEIGHT 22 ON CHANGE aget[9] := Form_2.CheckBox_1.Value
                Form_2.CheckBox_1.Value := aget[9]

                @ 46,45 CHECKBOX CheckBox_2 CAPTION "MD5 Password Authentication" ;
                        WIDTH 200 HEIGHT 22 ON CHANGE aget[10] := Form_2.CheckBox_2.Value
                Form_2.CheckBox_2.Value := aget[10]

                @ 81,25 LABEL Label_1 VALUE "User Name" WIDTH 90 HEIGHT 22
                @ 107,25 LABEL Label_2 VALUE "Password" WIDTH 92 HEIGHT 22

                @ 76,125 TEXTBOX Text_1 HEIGHT 22 WIDTH 222 ON CHANGE aget[11] := Form_2.Text_1.Value
                Form_2.Text_1.Value := aget[11]

                @ 103,125 TEXTBOX Text_2 HEIGHT 22 WIDTH 222 PASSWORD ON CHANGE aget[12] := Form_2.Text_2.Value
                Form_2.Text_2.Value := aget[12]

             // ini CdQ Mod
             // @ 156,140 BUTTON Button_1 CAPTION "OK" ACTION Form_2.Release WIDTH 80 HEIGHT 26 DEFAULT
                @ 156,140 BUTTON Button_1 CAPTION "OK" ACTION Form_2.Release WIDTH 80 HEIGHT 26
             // end CdQ Mod

                ON KEY ESCAPE ACTION Form_2.Button_1.OnClick

        END WINDOW

        CENTER WINDOW Form_2

        ACTIVATE WINDOW Form_2

RETURN

STATIC FUNCTION m_about()
RETURN MsgInfo("Harbour Mailer version 1.0 - Freeware" + CRLF + ;
        "Copyright (c) 2005 Grigory Filatov" + CRLF + CRLF + ;
        padc("Email: gfilatov@rambler.ru", 36) + CRLF + CRLF + ;
        hb_compiler() + CRLF + ;
        version() + CRLF + ;
        substr(MiniGuiVersion(), 1, 28), "About", IDI_MAIN, .f.)

STATIC PROCEDURE File_Attached()
   LOCAL i, cNewAtt := GetFile( { {"All Files", "*.*"}, ;
                {"ZIP Archives", "*.zip"}, {"RAR Archives", "*.rar"} }, ;
                "Select a File(s) To Attach", , .T. )

   if !empty( cNewAtt )

      aGet[7] := {}
      Form_1.Combo_7.DeleteAllItems

      if valtype(cNewAtt) == 'C'

         Form_1.Combo_7.AddItem(cNewAtt)
         aAdd(aGet[7], cNewAtt)

      elseif valtype(cNewAtt) == 'A'

         for i := 1 to len(cNewAtt)

             Form_1.Combo_7.AddItem(cNewAtt[i])
             aAdd(aGet[7], cNewAtt[i])

         next i

      endif

      Form_1.Combo_7.Value := 1

   endif

RETURN

STATIC PROCEDURE SaveData()
   LOCAL i

   SET DECIMALS TO

   BEGIN INI FILE cCfgFile

      For i := 1 To Len(aEntry)
        IF i == 8
                aGet[i] := STRTRAN( aGet[i], CRLF, Chr(250) )
        ELSEIF i == 12
        // ini CdQ Mod
        //      aGet[i] := CHARXOR( aGet[i], cCryptKey )
                if !empty( aGet[i] )
                   aGet[i] := CHARXOR( aGet[i], cCryptKey )
                endif
        // end CdQ Mod
        ENDIF
        SET SECTION "Data" ENTRY aEntry[i] TO aGet[i]
      Next i

   END INI

RETURN

#pragma BEGINDUMP
//#include <shlobj.h>
//#include <commctrl.h>
#include <windows.h>
#include "hbapi.h"
//#include "hbvm.h"
//#include "hbstack.h"
//#include "hbapiitm.h"

HB_FUNC ( GETEXENAME )

{
   BYTE bBuffer[ MAX_PATH + 1 ] = { 0 } ;

   GetModuleFileName( ( HMODULE ) hb_parnl( 1 ), ( char * ) bBuffer, 249 );
   hb_retc( ( char * ) bBuffer );
}
#pragma ENDDUMP
